Generic Image Library: virtual_2d_locator< Deref, IsTransposed > Class Template Reference

###  | #  |

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Friends | List of all members
virtual_2d_locator< Deref, IsTransposed > Class Template Reference
Models | Models

A 2D locator over a virtual image. Upon dereferencing, invokes a given function object passing it its coordinates. Models: PixelLocatorConcept, HasDynamicXStepTypeConcept, HasDynamicYStepTypeConcept, HasTransposedTypeConcept. More...

`#include <virtual_locator.hpp>`

Inheritance diagram for virtual_2d_locator< Deref, IsTransposed >:

## Public Types
typedef pixel_2d_locator_base < virtual_2d_locator< Deref, IsTransposed > , position_iterator< Deref, IsTransposed > , position_iterator< Deref, 1-IsTransposed > > | parent_t
typedef virtual_2d_locator < typename Deref::const_t, IsTransposed > | const_t
typedef Deref | deref_fn_t
typedef parent_t::point_t | point_t
typedef parent_t::coord_t | coord_t
typedef parent_t::x_coord_t | x_coord_t
typedef parent_t::y_coord_t | y_coord_t
typedef parent_t::x_iterator | x_iterator
typedef parent_t::y_iterator | y_iterator
Public Types inherited from pixel_2d_locator_base< virtual_2d_locator< Deref, IsTransposed >, position_iterator< Deref, IsTransposed >, position_iterator< Deref, 1-IsTransposed > >
typedef position_iterator < Deref, IsTransposed > | x_iterator
typedef position_iterator < Deref, 1-IsTransposed > | y_iterator
typedef std::iterator_traits < x_iterator >::value_type | value_type
typedef std::iterator_traits < x_iterator >::reference | reference
typedef std::iterator_traits < x_iterator > ::difference_type | coord_t
typedef point2< coord_t > | difference_type
typedef difference_type | point_t
typedef point_t::template axis < 0 >::coord_t | x_coord_t
typedef point_t::template axis < 1 >::coord_t | y_coord_t
typedef difference_type | cached_location_t

## Public Member Functions
| virtual_2d_locator (const point_t &p=point_t(0, 0), const point_t &step=point_t(1, 1), const deref_fn_t &d=deref_fn_t())
template<typename D , bool TR>
| virtual_2d_locator (const virtual_2d_locator< D, TR > &loc, coord_t y_step)
template<typename D , bool TR>
| virtual_2d_locator (const virtual_2d_locator< D, TR > &loc, coord_t x_step, coord_t y_step, bool transpose=false)
template<typename D , bool TR>
| virtual_2d_locator (const virtual_2d_locator< D, TR > &pl)
| virtual_2d_locator (const virtual_2d_locator &pl)
bool | operator== (const this_t &p) const
x_iterator & | x ()
y_iterator & | y ()
x_iterator const & | x () const
y_iterator const & | y () const
y_coord_t | y_distance_to (const this_t &it2, x_coord_t) const
bool | is_1d_traversable (x_coord_t) const
const point_t & | pos () const
const point_t & | step () const
const deref_fn_t & | deref_fn () const
Public Member Functions inherited from pixel_2d_locator_base< virtual_2d_locator< Deref, IsTransposed >, position_iterator< Deref, IsTransposed >, position_iterator< Deref, 1-IsTransposed > >
bool | operator!= (const virtual_2d_locator< Deref, IsTransposed > &p) const
x_iterator | x_at (x_coord_t dx, y_coord_t dy) const
x_iterator | x_at (const difference_type &d) const
y_iterator | y_at (x_coord_t dx, y_coord_t dy) const
y_iterator | y_at (const difference_type &d) const
virtual_2d_locator< Deref, IsTransposed > | xy_at (x_coord_t dx, y_coord_t dy) const
virtual_2d_locator< Deref, IsTransposed > | xy_at (const difference_type &d) const
axis< D >::iterator & | axis_iterator ()
axis< D >::iterator const & | axis_iterator () const
axis< D >::iterator | axis_iterator (const point_t &p) const
reference | operator() (x_coord_t dx, y_coord_t dy) const
reference | operator[] (const difference_type &d) const
reference | operator* () const
virtual_2d_locator< Deref, IsTransposed > & | operator+= (const difference_type &d)
virtual_2d_locator< Deref, IsTransposed > & | operator-= (const difference_type &d)
virtual_2d_locator< Deref, IsTransposed > | operator+ (const difference_type &d) const
virtual_2d_locator< Deref, IsTransposed > | operator- (const difference_type &d) const
cached_location_t | cache_location (const difference_type &d) const
cached_location_t | cache_location (x_coord_t dx, y_coord_t dy) const

## Friends
template<typename D , bool TR>
class | virtual_2d_locator

## Additional Inherited Members
Static Public Attributes inherited from pixel_2d_locator_base< virtual_2d_locator< Deref, IsTransposed >, position_iterator< Deref, IsTransposed >, position_iterator< Deref, 1-IsTransposed > >
static const std::size_t | num_dimensions

## Detailed Description

### template<typename Deref, bool IsTransposed>
class boost::gil::virtual_2d_locator< Deref, IsTransposed >

A 2D locator over a virtual image. Upon dereferencing, invokes a given function object passing it its coordinates. Models: PixelLocatorConcept, HasDynamicXStepTypeConcept, HasDynamicYStepTypeConcept, HasTransposedTypeConcept.

The documentation for this class was generated from the following file:

- virtual_locator.hpp